=== debian/changelog ===
feather-wallet (2.7.0+dfsg-1) unstable; urgency=medium

  * Initial release (closes: #1086975).

 -- Soren Stoutner <soren@debian.org>  Mon, 17 Mar 2025 21:07:39 -0700
