=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=auto,pgpsigurlmangle=s/$/.asc/ \
    https://featherwallet.org/files/releases/source/feather-(.+).tar.gz
